/*
 * Copyright (c) by Shuu Yamaguchi <shuu@dotAster.com>
 *
 * $Id: aoi.h,v 1.4 2003/05/08 05:37:04 shuu Exp shuu $
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */
#ifndef	__AOI_H
#define	__AOI_H

#include	<syslog.h>

#define	ACTION_NONE	0
#define ACTION_NEW	(1<<0)
#define	ACTION_EXIST	(1<<1)

#define AOI_NO	0
#define AOI_YES	1

#define	LOG_LEVEL	LOG_INFO

#define	AOI_DEVICE	"device"
#define AOI_FILE	"file"
#define AOI_STRING	"string"
#define AOI_BRE		"bre"
#define AOI_ERE		"ere"
#define AOI_CALL	"call"

#define LIST_MAX	16

enum aoi_match { FAIL, STRING, BRE, ERE };

struct node {
	struct node *left;
	struct node *right;
};

struct aoi_node {
	struct node node;
	int flag;
	char *name;
	unsigned long blocks;
};

struct aoi_data {
	int sum;
	struct node *head;
};

extern char *conf_list[];

/* aoi_node.c */
extern struct aoi_node * create_aoi_node(char *,unsigned long);
extern void destroy_aoi_node(struct aoi_node *);
extern void remove_aoi_node(struct aoi_data *);
extern int find_aoi_node(struct aoi_data *,char *);
/* device.c */
extern int get_device(char ***,struct aoi_data *,int);
/* node.c */
extern void add_node(struct aoi_data *,struct node *);
extern void remove_node(struct aoi_data *,struct node *);
/* read_conf.c */
extern char *** read_conf(char *);
/* match.c */
extern int find_device(char ***,char *);
extern int match_conf(char **);
/* call.c */
extern void call(char *,char **);

#endif /* __AOI_H */
