/*
 * Copyright (c) by Shuu Yamaguchi <shuu@dotAster.com>
 *
 * $Id: aoi_node.c,v 1.3 2003/05/22 03:21:31 shuu Exp shuu $
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"aoi.h"

struct aoi_node *
create_aoi_node(char *name,unsigned long blocks)
{
	struct aoi_node *an;

	an = (struct aoi_node *)malloc(sizeof(struct aoi_node));
	if (an == NULL)
		return NULL;
	an->name = strdup(name);
	if (an->name == NULL)
		return NULL;
	an->blocks = blocks;
#ifdef	DEBUG
	printf("allocate \"%s\" %lu\n",an->name,an->blocks);
#endif
	an->flag = ACTION_NEW;

	return an;
}

void
destroy_aoi_node(struct aoi_node *an)
{
#ifdef	DEBUG
	printf("free %s\n",an->name);
#endif
	free(an->name);
	free(an);
}

int
find_aoi_node(struct aoi_data *ad,char *name)
{
	struct node *np;
	struct aoi_node *an;

	if (ad->head == NULL)
		return AOI_NO;

	np = ad->head;
	do {
		an = (struct aoi_node *)np;
		if (strcmp(an->name,name) == 0) {
			an->flag = ACTION_EXIST;
			return AOI_YES;
		}
		np = np->right;
	} while(np != ad->head);

	return AOI_NO;
}

void
remove_aoi_node(struct aoi_data *ad)
{
	struct node *np;
	struct aoi_node *an;

	if (ad->head == NULL)
		return;

	np = ad->head;
	do {
		an = (struct aoi_node *)np;
		if ((an->flag & (ACTION_EXIST|ACTION_NEW)) == ACTION_NONE) {
			remove_node(ad,np);
			destroy_aoi_node(an);
		}
		an->flag = ACTION_NONE;
		np = np->right;
	} while(np != ad->head);

}

