/*
 * Copyright (c) by Shuu Yamaguchi <shuu@dotAster.com>
 *
 * $Id: device.c,v 1.5 2003/05/22 03:23:01 shuu Exp shuu $
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */
#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#include	<ctype.h>

#include	"aoi.h"

#define	PARTITION	"/proc/partitions"

#define LINEMAX_PARTITION	256

int
get_device(char ***table,struct aoi_data *ad,int first)
{
	static FILE *fp;
	char buf[LINEMAX_PARTITION],*startp,*endp;
	char name[128];
	struct aoi_node *an;
	int line,len;
	int major,minor,blocks;

	
	if (first) {
		if ((fp = fopen(PARTITION,"r")) == NULL)
			return -1;
	} else {	/* second and later */
		rewind(fp);
	}
	if (fgets(buf,LINEMAX_PARTITION,fp) == NULL)
		return -1;
	if (fgets(buf,LINEMAX_PARTITION,fp) == NULL)
		return -1;
	while(fgets(buf,LINEMAX_PARTITION,fp) != NULL) {
		startp = buf;
		major = (int)strtoul(startp,&endp,10);
		startp = endp;
		minor = (int)strtoul(startp,&endp,10);
		startp = endp;
		blocks = (int)strtoul(startp,&endp,10);
		while(*endp == ' ')
			endp++;
		startp = endp;
		while(! isspace(*endp))
			endp++;
		len = endp - startp;
		strncpy(name,startp,len);
		name[len] = '\0';

		if (find_aoi_node(ad,name) == AOI_NO) {
			an = create_aoi_node(name,blocks);
			add_node(ad,(struct node *)an);
			/* only build nodes
			 * blocks == 1 -> logical partition table
			 */
			if (first || blocks == 1)
				continue;
			if ((line = find_device(table,name)) != -1) {
				syslog(LOG_LEVEL,"device \"%s\" was found\n",name);
#ifdef DEBUG
				printf("device \"%s\" was found\n",name);
#endif
				if (match_conf(table[line]) == AOI_YES) {
					syslog(LOG_LEVEL,"\"%s\" was matched\n",name);
					call(name,table[line]);
				}
			}
		}
#ifdef DEBUG
		printf("device \"%s\"\n",name);
#endif
	}

#if 0
	fclose(fp);
#endif
	return 0;
}
