#include	<stdio.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<unistd.h>
#include	<getopt.h>

#include 	<gtk/gtk.h>

#define	LABEL_EXEC	"Execute"
#define LABEL_CANCEL	"Cancel"

int flag_q;

static void
exec_term(GtkWidget *widget, gpointer data)
{
	char *cmd[] = {"sh","-c",NULL,NULL};

	cmd[2] = (char *)data;
	if (flag_q) {
		execvp(cmd[0], cmd);
	} else {
		switch(fork()) {
		case 0:	/* child */
			execvp(cmd[0], cmd);
			g_print("execvp error\n");
			break;
		default:
			wait(NULL);
			break;
		}
	}
}

static void
delete_event(GtkWidget *widget,GdkEvent *event, gpointer data)
{
#ifdef DEBUG
	g_print("delete_event\n");
#endif
	gtk_main_quit();
}

static GtkWidget *
make_label(char *str)
{
	GtkWidget *label;

	label = gtk_label_new(str);
	gtk_widget_show(label);

	return label;
}

static GtkWidget *
make_box_button(char *str)
{
	GtkWidget *hbox;
	GtkWidget *button;

	hbox = gtk_hbox_new(TRUE,0);

	if (str != NULL) {
		/* exec button */
		button = gtk_button_new_with_label(LABEL_EXEC);
		gtk_signal_connect(GTK_OBJECT(button),"clicked",
			GTK_SIGNAL_FUNC(exec_term), (gpointer)str);
		gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, FALSE,0);
		gtk_widget_show(button);
	}

	/* cancel button */
	button = gtk_button_new_with_label(LABEL_CANCEL);
	gtk_signal_connect(GTK_OBJECT(button),"clicked",
		GTK_SIGNAL_FUNC(delete_event), NULL);
	gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, FALSE,0);
	gtk_widget_show(button);

	return hbox;
}

static void
usage(void)
{
	puts("[options]");
	puts("e <command>: executive command");
	puts("m <message>: text message");
	puts("t <title>: window title");
	puts("h: show this help");
	puts("q: quit");
}

int
main(int argc,char **argv)
{
	GtkWidget *window;
	GtkWidget *vbox,*hbox;
	GtkWidget *label;
	int ch;
	char *str_label = NULL,*str_exec = NULL,*str_title = NULL;

	gtk_init(&argc,&argv);
	while((ch = getopt(argc,argv,"m:e:qt:h")) != -1) {
		switch(ch){
		case 'm':
			str_label = optarg;
			break;
		case 'e':
			str_exec = optarg;
			break;
		case 't':
			str_title = optarg;
			break;
		case 'q':
			flag_q = 1;
			break;
		case 'h':
		default:
			usage();
			exit(0);
			break;
		}
	}

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	if (str_title)
		gtk_window_set_title(GTK_WINDOW(window),str_title);

	gtk_signal_connect(GTK_OBJECT(window),"delete_event",
		GTK_SIGNAL_FUNC(delete_event), NULL);
	gtk_container_set_border_width(GTK_CONTAINER(window), 10);

	vbox = gtk_vbox_new(FALSE,0);

	if (str_label != NULL) {
		label = make_label(str_label);
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE,0);
	}

	hbox = make_box_button(str_exec);
	gtk_widget_show(hbox);

	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE,FALSE,0);
	gtk_container_add(GTK_CONTAINER(window), vbox);
	gtk_widget_show(vbox);
	gtk_widget_show(window);

	gtk_main();

	return 0;
}

