/*
 * Copyright (c) by Shuu Yamaguchi <shuu@dotAster.com>
 *
 * $Id: main.c,v 1.6 2003/05/23 07:32:06 shuu Exp shuu $
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */
#include	<stdio.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<unistd.h>

#include	"aoi.h"

static void
init_aoi_data(struct aoi_data *ad)
{
	ad->sum = 0;
	ad->head = NULL;
}

void
watch(unsigned int sleep_time)
{
	char ***table;
	struct aoi_data aoi_data;
	int first = 1;
#ifdef	DEBUG
	unsigned int count = 0;
#endif

	init_aoi_data(&aoi_data);

	if ((table = read_conf(AOI_TABLE)) == NULL) {
		printf("read_conf error\n");
		return;
	}

	while(1) {
#ifdef DEBUG
		printf("--- %d ---\n",count++);
#endif
		if (get_device(table,&aoi_data,first) == -1)
			break;
		remove_aoi_node(&aoi_data);
		sleep(sleep_time);
		first = 0;
	}
}

#ifndef	DEBUG
static void
daemonize(void)
{
	switch(fork()) {
	case 0:		/* child */
		setsid();
		close(0);
		close(1);
		close(2);
		chdir("/");
		break;
	case -1:
		exit(1);
	default:	/* parent */
		exit(0);
	}
}
#endif

int
main(int argc,char **argv)
{
	if (argc != 1) {
		printf("Aoi version: %s\n",AOI_VERSION);
		exit(1);
	}
#ifdef	DEBUG
	openlog("aoi",LOG_PID|LOG_PERROR,LOG_DAEMON);
#else
	openlog("aoi",LOG_PID,LOG_DAEMON);
	daemonize();
#endif
	syslog(LOG_LEVEL,"start");
	watch(3);

	closelog();

	return 0;
}
